lib/cms_web/router.ex
defmodule CmsWeb.Router do
  use CmsWeb, :router
  use Pow.Phoenix.Router
  use Pow.Extension.Phoenix.Router, otp_app: :cms

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  pipeline :protected do
    plug Pow.Plug.RequireAuthenticated, error_handler: Pow.Phoenix.PlugErrorHandler
  end


  scope "/" do
    pipe_through :browser

    pow_routes()
    pow_extension_routes()
  end


  scope "/", CmsWeb do
    pipe_through [:browser, :protected]

    resources "/articles", ArticleController
    resources "/episodes", EpisodeController
    resources "/resources", ResourceController
    resources "/topics", TopicController
    get "/tagged/:topic", TopicController, :tagged
  end

  scope "/", CmsWeb do
    pipe_through :browser

    get "/", PageController, :index
  end
  # Other scopes may use custom stacks.
  # scope "/api", CmsWeb do
  #   pipe_through :api
  # end
end

lib/cms_web/templates/resource/edit.html.eex
<h1>Edit Resource</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.resource_path(@conn, :update, @resource)) %>

<span><%= button "Back", to: Routes.resource_path(@conn, :index), method: "get", class: "button-outline" %></span>

lib/cms_web/templates/resource/form.html.eex
<%= form_for @changeset, @action, fn f -> %>
  <%= if @changeset.action do %>
    <div class="alert alert-danger">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

  <%= label f, :title %>
  <%= text_input f, :title %>
  <%= error_tag f, :title %>

  <%= label f, :slug %>
  <%= text_input f, :slug %>
  <%= error_tag f, :slug %>

  <%= label f, :content %>
  <%= textarea f, :content %>
  <%= error_tag f, :content %>

  <%= label f, :url %>
  <%= text_input f, :url %>
  <%= error_tag f, :url %>

  <%= label f, :topics %>
  <%= text_input f, :topics, value: @tags %>
  <%= error_tag f, :topics %>

  <div>
    <%= submit "Save" %>
  </div>
<% end %>

lib/cms_web/templates/resource/index.html.eex
<h1>Listing Resources</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Slug</th>
      <th>Content</th>
      <th>Url</th>
      <th>Topics</th>

      <th></th>
    </tr>
  </thead>
  <tbody>
<%= for resource <- @resources do %>
    <tr>
      <td><%= resource.title %></td>
      <td><%= resource.slug %></td>
      <td><%= resource.content %></td>
      <td><%= resource.url %></td>

      <td class="topics">
        <%= for topic <- resource.entity.topics do %>
          <%= link to: Routes.topic_path(@conn, :tagged, topic) do %><div class="stamp"><%= topic.text %></div><% end %>
        <% end %>
      </td>

      <td>
        <%= button "Show", to: Routes.resource_path(@conn, :show, resource), method: "get", class: "button-outline button-small" %>
        <%= button "Edit", to: Routes.resource_path(@conn, :edit, resource), method: "get", class: "button-small" %>
        <%# <%= link "Delete", to: Routes.resource_path(@conn, :delete, resource), method: :delete, data: [confirm: "Are you sure?"] %>
      </td>
    </tr>
<% end %>
  </tbody>
</table>

<span><%= button "New Resource", to: Routes.resource_path(@conn, :new), method: "get" %></span>

lib/cms_web/templates/resource/new.html.eex
<h1>New Resource</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.resource_path(@conn, :create)) %>

<span><%= button "Back", to: Routes.resource_path(@conn, :index), method: "get" %></span>

lib/cms_web/templates/resource/show.html.eex
<h1>Show Resource</h1>

<ul>

  <li>
    <strong>Title:</strong>
    <%= @resource.title %>
  </li>

  <li>
    <strong>Slug:</strong>
    <%= @resource.slug %>
  </li>

  <li>
    <strong>Content:</strong>
    <%= @resource.content %>
  </li>

  <li>
    <strong>Url:</strong>
    <%= @resource.url %>
  </li>

</ul>

<span><%= button "Edit", to: Routes.resource_path(@conn, :edit, @resource), method: "get" %></span>
<span><%= button "Back", to: Routes.resource_path(@conn, :index), method: "get", class: "button-outline" %></span>